//package adaptadorl4;

import javax.swing.*;
import java.awt.*;
import java.awt.geom.*;
import java.util.*;
import java.awt.event.*;


/**
 * basePanel. Esta clase genera una plantilla estandar para la inserción de
 * imagenes de fondo o background en los paneles que se generar a partr de 
 * esta clase.
 * @author Sabina Torres Figueroa
 * @author Pedro Duran Caneo
 * @author Jorge Pareja Ayala
 */
public class basePanel extends JPanel
{

protected Smith carta;
private Image imgFondo;


/**
 * Constructor. Este recibe como argumento de entrada una referencia a la 
 * carta Smith que se utilizará dentro del applet.
 * @param cs Carta Smith que se utilizará para trabajar.
 */ 
public basePanel( Smith cs )
{
	carta = cs;
	imgFondo = null;
}

/**
 * Constructor. Este recibe como argumentos de entrada una referencia a la 
 * carta Smith que se utilizará dentro del applet y una referencia a String que
 * contiene el nombre del fichero de imagen que se empleará como fondo del panel.
 * @param cs Carta Smith que se utilizará para trabajar.
 * @param img Imagen para ser utilizada como fondo del panel.
 */
public basePanel( Smith cs, String img )
{
	carta = cs;
	preInit(img);
}

/**
 * showImgBg. Método que define como fondo de panel o backgound la imagen que se 
 * pasa como argumento de entrada.
 * @param img Imagen para ser utilizada como fonde del panel.
 */
public void showImgBg(String img)
{
	preInit(img);
	
}


/**
 * preInit. Método privado que establece como fondo de panel o backgound la imagen que
 * se pasa como argumento de entrada.
 * @param img Imagen para ser utilizada como fonde del panel.
 */
private void preInit( String img )
{
	imgFondo = new ImageIcon(getClass().getResource(img)).getImage();
}

/**
 * paintComponent. Método privado que establece como fondo de panel o backgound la imagen que
 * se pasa como argumento de entrada.
 * @param g elemento gráfico que se utilizará para establecer la imagen como background.
 */
protected void paintComponent(Graphics g)
{
	if(imgFondo != null)
		g.drawImage(imgFondo,0,0,this.getWidth(), this.getHeight(),this);
}



}
