//package adaptadorl4;

import javax.swing.border.EtchedBorder;
import javax.swing.*;
import java.awt.*;
import java.awt.geom.*;
import java.util.*;
import java.awt.event.*;

/**
 * buttomPanel. Esta clase es la encargada de desplegar en pantalla las imagenes
 * de los componentes que van siendo agregador por el usuario para ver
 * gráficamente el circuito equivalente que se está analizando.
 * @author Sabina Torres Figueroa
 * @author Pedro Duran Caneo
 * @author Jorge Pareja Ayala
 */
public class buttomPanel extends basePanel
{

/**
 * Constructor. Este recibe como parametros de entrada la carta Smith que 
 * se utilizará para trabajar y la imagen de la carga para el circuito
 * equivalente que será desplegado en pantalla para una mejor comprensión del
 * problema.
 * @param cs Carta Smith que se utilizará para trabajar.
 * @param load Imagen de la carga para el circuito equivalente.
 */
public buttomPanel(Smith cs, String load)
{
	//repaint((long)100);
	super(cs);
	addComponent(load);
	validate();

}

/**
 * Constructor. Este recibe como parametros de entrada la carta Smith que 
 * se utilizará para trabajar, la imagen que se utilizará como fondo de pantalla
 * y la imagen de la carga para el circuito equivalente que será desplegado en
 * pantalla para una mejor comprensión del problema.
 * @param cs Carta Smith que se utilizará para trabajar.
 * @param img Imagen para ser utilizada como fondo del panel.
 * @param load Imagen de la carga para el circuito equivalente.
 */
public buttomPanel(Smith cs, String img, String load)
{
	//repaint((long)100);
	super(cs,img);
	addComponent(load);
	validate();

}

/**
 * Método utilizado para agregar componentes al circuito equivalente desplegado
 * en pantalla.
 * Para su correcto funcionamiento, se debe ingresar como parámetro el nombre
 * de la imagen del componente que se desea agregar.
 * @param who Nombre de la imagen del componente para el circuito equivalente.
 */
public void addComponent(String who)
{

	if(who == "Impedancia")
		who="Zeta.jpg";
	else if(who == "Reactancia Capacitiva")
		who="rCap.jpg";
	else if(who == "Reactancia Inductiva")
		who="rInd.jpg";
	else if(who == "Resistor")
		who="Res.jpg";
	else if(who == "Admitancia")
		who="Admi.jpg";
	else if(who == "Suseptancia Capacitiva")
		who="sCap.jpg";
	else if(who == "Conductancia")
		who="Cond.jpg";
	else if(who == "Linea de Tx")
		who="Line.jpg";	

	JLabel element = new JLabel();
	element.setIcon(new ImageIcon(getClass().getResource(who)));
	element.setBorder(new EtchedBorder(EtchedBorder.RAISED));
	add(element);

}

/**
 * Método utilizado para eliminar componentes al circuito equivalente desplegado
 * en pantalla. Retorna verdadero si se efectuo la eliminacion o falso si no.
 * @return Verdadero si se efectuo correctamente la operación, falso si es que no.
 */
public boolean delComponent()
{

return true;

}

}
