//package adaptadorl4;

import javax.swing.*;
import java.awt.*;
import java.awt.geom.*;
import java.util.*;
import java.awt.event.*;

/**
 * centralPanel. Esta clase es la encargada de desplegar en pantalla la
 * carta Smith para que se vean los resultados gráficamente en la pantalla.
 * @author Sabina Torres Figueroa
 * @author Pedro Duran Caneo
 * @author Jorge Pareja Ayala
 */
public class centralPanel extends basePanel
{

/**
 * Constructor. Este recibe como parametro de entrada la carta Smith que 
 * se utilizará para trabajar.
 * @param cs Carta Smith que se utilizará para trabajar.
 */
public centralPanel(Smith cs)
{
	//repaint((long)100);
	super(cs);
	setOpaque(true);
	setBackground(Color.WHITE);
	add(cs);
	validate();
	repaint();
	

}

/**
 * Constructor. Este recibe como parametros de entrada la carta Smith que 
 * se utilizará para trabajar y la imagen que se utilizará como fondo del panel.
 * @param cs Carta Smith que se utilizará para trabajar.
 * @param img Imagen para ser utilizada como fondo del panel.
 */
public centralPanel(Smith cs, String img)
{
	//repaint((long)100);
	super(cs,img);
	setOpaque(true);
	setBackground(Color.WHITE);
	add(cs);
	validate();
	repaint();
	
}


}
