//package adaptadorl4;

import javax.swing.*;
import java.awt.*;
import java.awt.geom.*;
import java.util.*;
import java.awt.event.*;
import java.text.DecimalFormat;

/**
 * leftPanel. Esta clase es la encargada de desplegar en pantalla los componentes
 * para ingresar datos y también para desplegar los resultador. Para ello usa
 * las clases JLabel, JTextField, JButtom que conforman la parte gráfica del 
 * panel.
 * @author Sabina Torres Figueroa
 * @author Pedro Duran Caneo
 * @author Jorge Pareja Ayala
 */
public class leftPanel extends basePanel
{

  private double	Fcia, Real, Imag, epsilonr;
  public double Zo;
  private DecimalFormat df;
  private String	s_fcia,s_real,s_imag,s_zo, s_epsilonr;
  private JTextField	data01, data02, data03, data04, data05, data06, data07, data08;
  private JLabel 	tex;
  private JButton	Adaptar, fBut, zBut;
  private buttomPanel butt;

/**
 * Pistener. Clase interna encargada de escuchar los eventos de la barra lateral.
 * Si coincide con alguno de los elementos que están dispuestos en la barra
 * lateral, analiza los datos ingresados por el usuario.
 */
class Pistener implements ActionListener
{

/**
 * actionPerformed. Método encargado de analizar los eventos ocurridos en los 
 * componentes gráficos del panel.
 * @param evento Objeto que se encarga de capturar el origen del evento.
 */
    public void actionPerformed(ActionEvent evento)
	{
		if (evento.getSource() == zBut)
		    {
		    	s_fcia = data01.getText();
		    	s_zo   = data02.getText();
		    	s_real = data03.getText();
		    	s_imag = data04.getText();
		    	s_epsilonr = data06.getText();
		    	parseData();

		    	data05.setEnabled(true);
		    	data07.setEnabled(true);
		    	data08.setEnabled(true);
		    	data04.setEnabled(false);
		    	data03.setEnabled(false);
		    	data02.setEnabled(false);
		    	data01.setEnabled(false);
		    	data06.setEnabled(false);
		    	
		    	zineq();
		    	
		    }

		if ( evento.getSource() == Adaptar )
		{
			data05.setEnabled(false);
			data07.setEnabled(false);
			data08.setEnabled(false);
		    	data04.setEnabled(true);
		    	data03.setEnabled(true);
		    	data02.setEnabled(true);
		    	data01.setEnabled(true);
		    	data06.setEnabled(true);
		    	
		    	adaptar();
		    	
		    	zineq();
			

		}
		
		    

	carta.repaint((long)100);
	}
 

}

/**
 * Constructor. Este recibe como parametro de entrada la carta Smith que 
 * se utilizará para trabajar y el panel inferior que contiene el circuito
 * equivalente asociado al problema.
 * @param cs Carta Smith que se utilizará para trabajar.
 * @param bt Panel inferior.
 */
public leftPanel(Smith cs, buttomPanel bt)
{
	//repaint((long)100);
	super(cs);
	butt = bt;
	Real = Imag = Zo = Fcia = 0;
	df = new DecimalFormat("0.00");
	validate();
	columna();

}

/**
 * Constructor. Este recibe como parametro de entrada la carta Smith que 
 * se utilizará para trabajar, la ruta para la imagen que se utilizará como
 * fondo del panel y el panel inferior que contiene el circuito equivalente
 * asociado al problema.
 * @param cs Carta Smith que se utilizará para trabajar.
 * @param img Imagen para ser utilizada como fondo del panel.
 * @param bt Panel inferior.
 */
public leftPanel(Smith cs, String img, buttomPanel bt)
{
	//repaint((long)100);
	super(cs,img);
	butt = bt;
	validate();

}

/**
 * columna. Método privado encargado de la creeación de los objetos y componentes 
 * necesarias para armar el panel lateral.
 * Además conecta los eventos de los componentes mediante una instancia de la 
 * clase interna Plistener.
 */
private void columna()
{
	JLabel label;
	Adaptar = new JButton("Adaptar");
	fBut	= new JButton("Ok");
	zBut	= new JButton("Ok");
	setLayout(new GridLayout(30,1));
	add(label = new JLabel("Datos Generales"));
	label.setFont(new Font("Serif", Font.BOLD, 16));
	add(new JLabel("Frecuencia [Mhz]:"));
	add(data01 = new JTextField());
	add(new JLabel("Zo [ohm]:"));
	add(data02 = new JTextField());
	add(new JLabel("Epsilon Relativo"));
	add(data06 = new JTextField());
	//columna.add(fBut);
	//columna.add(new JSeparator(JSeparator.HORIZONTAL));
	
	add(label = new JLabel("Z de Carga"));
	label.setFont(new Font("Serif", Font.BOLD, 16));
	add(new JLabel("Rl [ohm]:"));
	add(data03 = new JTextField());
	add(new JLabel("Xl [ohm]:"));
	add(data04 = new JTextField());
	add(zBut);
	add(new JSeparator(JSeparator.HORIZONTAL));
	
	add(label = new JLabel("Zin [ohm]:"));
	label.setFont(new Font("Serif", Font.BOLD, 16));
	add(data05 = new JTextField());
	
	add(label = new JLabel("Linea Adicional [m]:"));
	label.setFont(new Font("Serif", Font.BOLD, 16));
	add(data07 = new JTextField());
	
	add(label = new JLabel("Zt [ohm]:"));
	label.setFont(new Font("Serif", Font.BOLD, 16));
	add(data08 = new JTextField());
	
	
	data05.setEnabled(false);
	data07.setEnabled(false);
	data08.setEnabled(false);
	add(new JSeparator(JSeparator.HORIZONTAL));
	add(Adaptar);
	
	Pistener Plistener = new Pistener();
	
	Adaptar.addActionListener(Plistener);
	zBut.addActionListener(Plistener);

}

/**
 * Método privado que analiza los datos ingresados mediante los JTextField
 * para ello se utiliza el método estático parseDouble de la clase Double.
 */
private void parseData()
{
	Real = Double.parseDouble(s_real);
	Imag = Double.parseDouble(s_imag);
	Fcia = Double.parseDouble(s_fcia);
	Zo = Double.parseDouble(s_zo);
	epsilonr = Double.parseDouble(s_epsilonr);
	carta.setSerie(Real,Imag,Zo);
}

/**
 * Método privado que despliega en pantalla el valor de la impedancia equivalente
 * que tiene la carta Smith en el momento de su invocación.
 */
public void zineq()
{
    	s_zo = df.format(carta.getr())+" + "+df.format(carta.getx())+"j";		    	
	data05.setText(s_zo);
}

/**
 * Método privado que adapta el circuito equivalente desplegado en el panel 
 * inferior para ello debe eliminar la parte imeginaria de la impedancia
 * equivalente en la carta Smith y luego calcular los parametrós del transformador
 * lambda cuartos que adapte la linea de transmisión.
 */
private void adaptar()
{
double beta = (2*3.1416*Fcia*1000000*Math.sqrt(epsilonr))/300000000;
String st;
s_fcia = df.format((Math.atan(carta.getx()/carta.getr()))/(2*beta));
data07.setText(s_fcia);

carta.setSerie(0,-carta.getx(),Zo);
carta.setLinea(0.25,Math.sqrt(Zo*carta.getr()));

s_fcia = df.format(Math.sqrt(Zo*carta.getr()));
data08.setText(s_fcia);
butt.addComponent("imgL4/Adap.jpg");
butt.validate();

}

}
